// AllocationErr.cpp: dfinit le point d'entre pour l'application console.
//

#include "stdafx.h"
#include "AllocationErr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

using namespace std;


void ReportMemory()
{
	MEMORYSTATUSEX statex;

	statex.dwLength = sizeof (statex);
	GlobalMemoryStatusEx (&statex);

	TRACE("GlobalMemoryStatusEx:\n");
	TRACE(" + TotalVirtual : %0.1lf Mo\n", statex.ullTotalVirtual / (1024.0 * 1024.0));
	TRACE(" + AvailVirtual : %0.1lf Mo\n", statex.ullAvailVirtual / (1024.0 * 1024.0));
	TRACE(" + Process mem load : %0.1lf %%\n", (1.0 - (double) statex.ullAvailVirtual / (double) statex.ullTotalVirtual) * 100.0);
	TRACE(" + TotalPageFile : %0.1lf Mo\n", statex.ullTotalPageFile / (1024.0 * 1024.0));
	TRACE(" + AvailPageFile : %0.1lf Mo\n", statex.ullAvailPageFile / (1024.0 * 1024.0));
	TRACE("\n");
}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	TRACE("Avant allocation\n");
	ReportMemory();

	const unsigned int taille_bloc = 10* 1024, nb_blocs_max = (3U * 1024U * 1024U * 1024U / taille_bloc);
	int i = 0;

	char ** p = NULL;

	try
	{
		p = new char *[nb_blocs_max];

		memset(p, 0, nb_blocs_max * sizeof(char *));

		for(i = 0; i < nb_blocs_max; i++)
		{
			p[i] = new char[taille_bloc];
		}
	}
	catch (CMemoryException* e)
	{
		e->Delete();

		TRACE("Aprs dbordement mmoire\n");
		ReportMemory();

		for(i = 0; i < nb_blocs_max; i++)
		{
			if(p[i])
			{
				delete [] p[i];
			}
		}

		delete [] p;
	}

	TRACE("Aprs libration mmoire\n");
	ReportMemory();

	char * t = NULL;
	try
	{
		const unsigned int taille_max = 30 * 1024 * 1024;
		t = new char[taille_max];
	}
	catch (CMemoryException* e)
	{
		TRACE("Echec allocation mmoire aprs libration des ressources\n");
		e->Delete();

		if(t)
		{
			delete [] t;
		}
	}

	return 0;
}
